/*
 * File:          sidl_rmi_InstanceRegistry_Impl.c
 * Symbol:        sidl.rmi.InstanceRegistry-v0.9.0
 * Symbol Type:   class
 * Babel Version: 0.10.0
 * Release:       $Name:  $
 * Revision:      @(#) $Id: $
 * Description:   Server-side implementation for sidl.rmi.InstanceRegistry
 * 
 * Copyright (c) 2000-2002, The Regents of the University of California.
 * Produced at the Lawrence Livermore National Laboratory.
 * Written by the Components Team <components@llnl.gov>
 * All rights reserved.
 * 
 * This file is part of Babel. For more information, see
 * http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
 * for Our Notice and the LICENSE file for the GNU Lesser General Public
 * License.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License (as published by
 * the Free Software Foundation) version 2.1 dated February 1999.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
 * conditions of the GNU Lesser General Public License for more details.
 * 
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 * babel-version = 0.10.0
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sidl.rmi.InstanceRegistry" (version 0.9.0)
 * 
 * This singleton class is implemented by Babel's runtime for RMI libraries to 
 * invoke methods on server objects.  It is assumed that the RMI library
 * has a self-describing stream of data, but the data may be reordered
 * from the natural argument list.
 * 
 * 
 * In the case of the RMI library receiving a self-describing stream
 * and wishing to invoke a method on a class... the RMI library would 
 * make a sequence of calls like:
 * 
 *       sidl_BaseClass bc = sidl_rmi_InstanceRegistry_getInstance( "instanceID" );
 *       sidl_rmi_TypeMap inArgs = sidl_rmi_TypeMap__create();
 *       
 *       sidl_rmi_TypeMap_putDouble( inArgs, "input_val" , 2.0 );
 *       sidl_rmi_TypeMap_putString( inArgs, "input_str", "Hello" );
 *       ...
 *       sidl_rmi_TypeMap ourArgs = sidl_BaseClass_execMethod( bc, "methodName" , t );
 * 
 *       sidl_rmi_Response_unpackBool( i, "_retval", &succeeded );
 *       sidl_rmi_Response_unpackFloat( i, "output_val", &f );
 */

#include "sidl_rmi_InstanceRegistry_Impl.h"

/* DO-NOT-DELETE splicer.begin(sidl.rmi.InstanceRegistry._includes) */
/* Put additional includes or other arbitrary code here... */
/* DO-NOT-DELETE splicer.end(sidl.rmi.InstanceRegistry._includes) */

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sidl_rmi_InstanceRegistry__load"

void
impl_sidl_rmi_InstanceRegistry__load(
void)
{
  /* DO-NOT-DELETE splicer.begin(sidl.rmi.InstanceRegistry._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sidl.rmi.InstanceRegistry._load) */
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sidl_rmi_InstanceRegistry__ctor"

void
impl_sidl_rmi_InstanceRegistry__ctor(
  /*in*/ sidl_rmi_InstanceRegistry self)
{
  /* DO-NOT-DELETE splicer.begin(sidl.rmi.InstanceRegistry._ctor) */
  /* Insert the implementation of the constructor method here... */
  /* DO-NOT-DELETE splicer.end(sidl.rmi.InstanceRegistry._ctor) */
}

/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sidl_rmi_InstanceRegistry__dtor"

void
impl_sidl_rmi_InstanceRegistry__dtor(
  /*in*/ sidl_rmi_InstanceRegistry self)
{
  /* DO-NOT-DELETE splicer.begin(sidl.rmi.InstanceRegistry._dtor) */
  /* Insert the implementation of the destructor method here... */
  /* DO-NOT-DELETE splicer.end(sidl.rmi.InstanceRegistry._dtor) */
}

/*
 * register an instance of a class
 *  the registry will return a string guaranteed to be unique for
 *  the lifetime of the process
 */

#undef __FUNC__
#define __FUNC__ "impl_sidl_rmi_InstanceRegistry_registerInstance"

char*
impl_sidl_rmi_InstanceRegistry_registerInstance(
  /*in*/ sidl_BaseClass instance)
{
  /* DO-NOT-DELETE splicer.begin(sidl.rmi.InstanceRegistry.registerInstance) */
  /* Insert the implementation of the registerInstance method here... */
  /* DO-NOT-DELETE splicer.end(sidl.rmi.InstanceRegistry.registerInstance) */
}

/*
 * returns a handle to the class based on the unique string
 */

#undef __FUNC__
#define __FUNC__ "impl_sidl_rmi_InstanceRegistry_getInstance"

sidl_BaseClass
impl_sidl_rmi_InstanceRegistry_getInstance(
  /*in*/ const char* instanceID)
{
  /* DO-NOT-DELETE splicer.begin(sidl.rmi.InstanceRegistry.getInstance) */
  /* Insert the implementation of the getInstance method here... */
  /* DO-NOT-DELETE splicer.end(sidl.rmi.InstanceRegistry.getInstance) */
}
