/*
 * File:          sidl_rmi_Invocation_IOR.h
 * Symbol:        sidl.rmi.Invocation-v0.9.0
 * Symbol Type:   interface
 * Babel Version: 0.10.0
 * Release:       $Name:  $
 * Revision:      @(#) $Id: $
 * Description:   Intermediate Object Representation for sidl.rmi.Invocation
 * 
 * Copyright (c) 2000-2002, The Regents of the University of California.
 * Produced at the Lawrence Livermore National Laboratory.
 * Written by the Components Team <components@llnl.gov>
 * All rights reserved.
 * 
 * This file is part of Babel. For more information, see
 * http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
 * for Our Notice and the LICENSE file for the GNU Lesser General Public
 * License.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License (as published by
 * the Free Software Foundation) version 2.1 dated February 1999.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
 * conditions of the GNU Lesser General Public License for more details.
 * 
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 * babel-version = 0.10.0
 */

#ifndef included_sidl_rmi_Invocation_IOR_h
#define included_sidl_rmi_Invocation_IOR_h

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifdef __cplusplus
extern "C" {
#endif

/*
 * Symbol "sidl.rmi.Invocation" (version 0.9.0)
 * 
 * This type is used to pack arguments and make the actual 
 * method invocation.
 */

struct sidl_rmi_Invocation__array;
struct sidl_rmi_Invocation__object;

/*
 * Forward references for external classes and interfaces.
 */

struct sidl_BaseException__array;
struct sidl_BaseException__object;
struct sidl_BaseInterface__array;
struct sidl_BaseInterface__object;
struct sidl_ClassInfo__array;
struct sidl_ClassInfo__object;
struct sidl_io_IOException__array;
struct sidl_io_IOException__object;
struct sidl_rmi_Response__array;
struct sidl_rmi_Response__object;

/*
 * Declare the method entry point vector.
 */

struct sidl_rmi_Invocation__epv {
  /* Implicit builtin methods */
  void* (*f__cast)(
    void* self,
    const char* name);
  void (*f__delete)(
    void* self);
  /* Methods introduced in sidl.BaseInterface-v0.9.0 */
  void (*f_addRef)(
    void* self);
  void (*f_deleteRef)(
    void* self);
  sidl_bool (*f_isSame)(
    void* self,
    struct sidl_BaseInterface__object* iobj);
  struct sidl_BaseInterface__object* (*f_queryInt)(
    void* self,
    const char* name);
  sidl_bool (*f_isType)(
    void* self,
    const char* name);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    void* self);
  /* Methods introduced in sidl.io.Serializer-v0.9.0 */
  void (*f_packBool)(
    void* self,
    const char* key,
    sidl_bool value,
    struct sidl_BaseInterface__object **_ex);
  void (*f_packChar)(
    void* self,
    const char* key,
    char value,
    struct sidl_BaseInterface__object **_ex);
  void (*f_packInt)(
    void* self,
    const char* key,
    int32_t value,
    struct sidl_BaseInterface__object **_ex);
  void (*f_packLong)(
    void* self,
    const char* key,
    int64_t value,
    struct sidl_BaseInterface__object **_ex);
  void (*f_packFloat)(
    void* self,
    const char* key,
    float value,
    struct sidl_BaseInterface__object **_ex);
  void (*f_packDouble)(
    void* self,
    const char* key,
    double value,
    struct sidl_BaseInterface__object **_ex);
  void (*f_packFcomplex)(
    void* self,
    const char* key,
    struct sidl_fcomplex value,
    struct sidl_BaseInterface__object **_ex);
  void (*f_packDcomplex)(
    void* self,
    const char* key,
    struct sidl_dcomplex value,
    struct sidl_BaseInterface__object **_ex);
  void (*f_packString)(
    void* self,
    const char* key,
    const char* value,
    struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in sidl.rmi.Invocation-v0.9.0 */
  struct sidl_rmi_Response__object* (*f_invokeMethod)(
    void* self);
};

/*
 * Define the interface object structure.
 */

struct sidl_rmi_Invocation__object {
  struct sidl_rmi_Invocation__epv* d_epv;
  void*                            d_object;
};

#ifdef __cplusplus
}
#endif
#endif
